<div [class]="inputGroupClass">
  <label *ngIf="mbConfig?.labelText !== null" class="input__label" [innerHTML]="mbConfig?.labelText"
  ><span *ngIf="mbRequired" style="color: red">*</span></label
  >
  <div
    *ngIf="mbConfig?.labelText === null && mbConfig?.showFlexEnd"
    class="input__group--no-label"
    [ngStyle]="!removeMinHeight && { 'min-height': '19px' }"
  ></div>
  <nz-input-group
    *ngIf="mbConfig?.groupType === 'icon' && !mbConfig?.isDatepicker"
    [nzPrefixIcon]="mbConfig?.prefixIcon"
    [nzPrefix]="mbConfig?.prefixTemplate"
    [nzSuffix]="mbConfig?.suffixTemplate"
    [nzSuffixIcon]="mbConfig.suffixIcon"
    [class]="inputGroupGroupClass"
  >
    <input *ngIf="mbInputType !== 'number'"
      appSpecialInput
      [class]="inputTextClass"
      [disabled]="mbConfig?.disable"
      [autofocus]="mbConfig?.autofocus"
      [autoFocus]='isFocus'
      nz-input
      [readOnly]="mbReadOnly"
      [maxLength]="mbMaxLength"
      [minLength]="mnMinLength"
      [placeholder]="mbConfig?.placeholder"
      (ngModelChange)="onInputChange($event)"
      [nzAutocomplete]="mbAutocomplete ?? auto"
      (keyup)="inputFill($event)"
      (blur)="inputBlur($event)"
      (click)="inputClick($event, value)"
      (focus)="inputFocus($event)"
      [(ngModel)]="value"
    />
    <input *ngIf="mbInputType === 'number'"
           type="number"
           [autoFocus]='isFocus'
           [disabled]="mbConfig?.disable"
           [autofocus]="mbConfig?.autofocus"
           [class]="inputTextClass"
           nz-input
           [readOnly]="mbReadOnly"
           [maxLength]="mbMaxLength"
           [minLength]="mnMinLength"
           [nzAutocomplete]="mbAutocomplete ?? auto"
           [placeholder]="mbConfig?.placeholder"
           (ngModelChange)="onInputChange($event)"
           (keyup)="inputFill($event)"
           (paste)="onPaste($event)"
           (blur)="inputBlur($event)"
           (click)="inputClick($event, value)"
           [(ngModel)]="value"
           (keypress)="preventTypeSpecialSymbol($event)"
           [min]='minNumber'
    />
  </nz-input-group>
  <nz-input-group
    *ngIf="mbConfig?.groupType === 'icon' && mbConfig?.isDatepicker"
    [nzPrefixIcon]="mbConfig?.prefixIcon"
    [nzPrefix]="mbConfig?.prefixTemplate"
    [nzSuffix]="mbConfig?.suffixTemplate"
    [nzSuffixIcon]="mbConfig.suffixIcon"
    [class]="inputGroupGroupClass"
  >
    <input
      appSpecialInput
      *ngIf="mbConfig?.isDatepicker === true"
      [autoFocus]='isFocus'
      [class]="inputTextClass"
      [disabled]="mbConfig?.disable"
      [autofocus]="mbConfig?.autofocus"
      nz-input
      bsDatepicker
      [bsConfig]="mbConfig?.dateConfig"
      [placeholder]="mbConfig?.placeholder"
      [readOnly]="mbReadOnly"
      [maxLength]="mbMaxLength"
      [minLength]="mnMinLength"
      [nzAutocomplete]="mbAutocomplete ?? auto"
      (ngModelChange)="onInputChange($event)"
      (keyup)="inputFill($event)"
      (blur)="inputBlur($event)"
      (click)="inputClick($event, value)"
      (focus)="inputFocus($event)"
      [(ngModel)]="value"
    />
  </nz-input-group>

  <ng-container *ngIf="mbConfig?.groupType === 'noIcon' && mbConfig?.isDatepicker === false && !defaultInput">
    <input *ngIf="mbInputType === 'text' && !isSpecial"
           appSpecialInput
           [autoFocus]='isFocus'
           [disabled]="mbConfig?.disable"
           [autofocus]="mbConfig?.autofocus"
           [class]="inputTextClass"
           nz-input
           [readOnly]="mbReadOnly"
           [maxLength]="mbMaxLength"
           [minLength]="mnMinLength"
           [nzAutocomplete]="mbAutocomplete ?? auto"
           [placeholder]="mbConfig?.placeholder"
           (ngModelChange)="onInputChange($event)"
           (keyup)="inputFill($event)"
           (blur)="inputBlur($event)"
           (click)="inputClick($event, value)"
           (focus)="inputFocus($event)"
           [(ngModel)]="value"
    />
    <input *ngIf="mbInputType === 'text' && isSpecial"
           [autoFocus]='isFocus'
           [disabled]="mbConfig?.disable"
           [autofocus]="mbConfig?.autofocus"
           [class]="inputTextClass"
           nz-input
           [readOnly]="mbReadOnly"
           [maxLength]="mbMaxLength"
           [minLength]="mnMinLength"
           [nzAutocomplete]="mbAutocomplete ?? auto"
           [placeholder]="mbConfig?.placeholder"
           (ngModelChange)="onInputChange($event)"
           (keyup)="inputFill($event)"
           (blur)="inputBlur($event)"
           (click)="inputClick($event, value)"
           (focus)="inputFocus($event)"
           [(ngModel)]="value"
    />
    <input *ngIf="mbInputType === 'number' && !isFormatterCurrency"
           type="number"
           [autoFocus]='isFocus'
           [disabled]="mbConfig?.disable"
           [autofocus]="mbConfig?.autofocus"
           [class]="inputTextClass"
           nz-input
           [readOnly]="mbReadOnly"
           [maxLength]="mbMaxLength"
           [minLength]="mnMinLength"
           [nzAutocomplete]="mbAutocomplete ?? auto"
           [placeholder]="mbConfig?.placeholder"
           (ngModelChange)="onInputChange($event)"
           (keyup)="inputFill($event)"
           (paste)="onPaste($event)"
           (blur)="inputBlur($event)"
           (click)="inputClick($event, value)"
           [(ngModel)]="value"
           (keypress)="preventTypeSpecialSymbol($event)"
           [min]='minNumber'
    />
    <nz-input-number *ngIf="mbInputType === 'number' && isFormatterCurrency" [autoFocus]='isFocus' nz-input
      [nzFormatter]="formatterCurrency"
      [nzParser]="parserCurrency"
      [disabled]="mbConfig?.disable"
      [nzAutoFocus]="mbConfig?.autofocus === 'autofocus' "
      [class]="inputTextClass"
      [nzReadOnly]="mbReadOnly"
      [nzPlaceHolder]="mbConfig?.placeholder ?? ''"
      (ngModelChange)="onInputChange($event)"
      (keyup)="inputFill($event)"
      (paste)="onPaste($event)"
      (blur)="inputBlur($event)"
      (click)="inputClick($event, value)"
      [(ngModel)]="value"
      (keypress)="preventTypeSpecialSymbol($event)"
      [nzMin]='+minNumber ?? 0'
      [nzMax]='maxNumber'
    ></nz-input-number>
  </ng-container>

  <input
    *ngIf="mbConfig?.groupType === 'noIcon' && mbConfig?.isDatepicker === false && defaultInput"
    [disabled]="mbConfig?.disable"
    [autofocus]="mbConfig?.autofocus"
    [autoFocus]="isFocus"
    [class]="inputTextClass"
    nz-input
    [readOnly]="mbReadOnly"
    [maxLength]="mbMaxLength"
    [minLength]="mnMinLength"
    [nzAutocomplete]="mbAutocomplete ?? auto"
    [placeholder]="mbConfig?.placeholder"
    (ngModelChange)="onInputChange($event)"
    (keyup)="inputFill($event)"
    (blur)="inputBlur($event)"
    (click)="inputClick($event, value)"
    (focus)="inputFocus($event)"
    [(ngModel)]="value"
  />
  <input
    appSpecialInput
    *ngIf="mbConfig?.groupType === 'noIcon' && mbConfig?.isDatepicker === true"
    [disabled]="mbConfig?.disable"
    [autofocus]="mbConfig?.autofocus"
    [autoFocus]="isFocus"
    [readOnly]="mbReadOnly"
    [maxLength]="mbMaxLength"
    [minLength]="mnMinLength"
    [nzAutocomplete]="mbAutocomplete ?? auto"
    [class]="inputTextClass"
    nz-input
    bsDatepicker
    [bsConfig]="mbConfig?.dateConfig"
    [placeholder]="mbConfig?.placeholder"
    (ngModelChange)="onInputChange($event)"
    (blur)="inputBlur($event)"
    (keyup)="inputFill($event)"
    (click)="inputClick($event, value)"
    (focus)="inputFocus($event)"
    [(ngModel)]="value"
  />
  <textarea
    appSpecialInput
    *ngIf="mbConfig?.groupType === 'textarea'"
    [disabled]="mbConfig?.disable"
    [autoFocus]='isFocus'
    [maxLength]="mbMaxLength"
    [minLength]="mnMinLength"
    [autofocus]="mbConfig?.autofocus"
    [rows]="mbConfig?.rows"
    [nzAutosize]="mbConfig?.autoSize"
    [class]="mbIsTextAreAutoResize ? inputAreaClass : inputTextClass"
    nz-input
    [placeholder]="mbConfig?.placeholder"
    (ngModelChange)="onInputChange($event)"
    (blur)="inputBlur($event)"
    (click)="inputClick($event, value)"
    (focus)="inputFocus($event)"
    [(ngModel)]="value"
  ></textarea>
  <textarea
    *ngIf="mbConfig?.groupType === 'textareaInputSpecial'"
    [disabled]="mbConfig?.disable"
    [maxLength]="mbMaxLength"
    [minLength]="mnMinLength"
    [autofocus]="mbConfig?.autofocus"
    [autoFocus]="isFocus"
    [rows]="mbConfig?.rows"
    [nzAutosize]="mbConfig?.autoSize"
    [class]="inputTextClass"
    nz-input
    [placeholder]="mbConfig?.placeholder"
    (ngModelChange)="onInputChange($event)"
    (blur)="inputBlur($event)"
    (click)="inputClick($event, value)"
    (focus)="inputFocus($event)"
    [(ngModel)]="value"
  ></textarea>
  <div *ngIf="mbConfig?.textMessageValue !== null && mbConfig?.showError" [class]="inputMessageClass">
    <em *ngIf="mbConfig?.showIcon" nz-icon [nzType]="iconType" nzTheme="outline"></em>
    <span class="text__message">{{ mbConfig?.textMessageValue }}</span>
  </div>
</div>

<nz-autocomplete #auto></nz-autocomplete>
